#pragma once
#include "chatmainview.h"
#include "UIChatElement.h"
#include "ScrollBarEx.h"
#define ID_CHAT_SCROLLBAR					(0xB012)

#define DEF_CHAT_SCROLL_SIZE				(50)
#define DEF_CHAT_MAIN_MIN_HEIGHT			(160)

#define CHAT_ELEMENTLIST_BOTTOM             (10)
#define CHAT_ELEMENTLIST_TOP				(10)


#define CHATMAIN_TIMER (100)




const DWORD CHATMAIN_TIME_OUT = 3000;
const REAL  CHATMAIN_USERNAME_LEFT = 38.0f;
const REAL  CHATMAIN_MSG_LEFT = 10.0f;

class CChatMainViewElementList : public CWnd
	, public CChatMainView, public IUIElementResouce
{
	DECLARE_DYNAMIC(CChatMainViewElementList)
public:
	CChatMainViewElementList(void);
	CChatMainViewElementList(CChatDlg*);
	virtual ~CChatMainViewElementList(void);
	


	//virtual BOOL	CreatePlainView(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID) { return FALSE; } 
	//virtual BOOL	CreateBubbleView(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID) { return FALSE; }
	virtual BOOL    CreateElementList(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, int nDisplayType);
	virtual UIElement*	AddChatItem(LPChatItemInfo pChatItemInfo, bool bRestore = true);
	virtual UIElement*	AddTranslateFileItem(LPChatItemInfo pChatItemInfo, TranslateFileInfoPtr& pTranslateFileInfo, bool bRestore = true);

	virtual void	ScrollToChatItem( CChatItem* pChItem );
	virtual void	ScrollToLastchatItem();
	//void			SetChatMsgResult(UINT nTid, CHAT_ITEM_STATE state);

	virtual void	ResetChatItem(UINT uTid);
	virtual void	DrawSelectedText(BOOL bSelection = TRUE, BOOL bSelectAll = FALSE);

	virtual HWND	GetChatSafeHwnd();
	virtual HWND	GetToolTipWindow();
	virtual bool	IsGroupRoom();
	virtual TOOLINFO* GetToolInfo();
	virtual BOOL	DestroyChatWindow();
	virtual void	MoveChatWindow(LPCRECT lpRect, BOOL bRepaint = TRUE);
	virtual CWnd*	GetCWnd();
	virtual void    SetChatDisplayType(int nType);
	virtual void    SetTestChatDisplayType(int nType);
	

	virtual Image* GetUserImage();
	virtual	Image* GetSendStatusImage(int nIndex);
	virtual Image* GetSysMsgBGImage();
	virtual Image* GetSysMsgArrowImage();
	virtual Image* GetImgDateBGImage(int nIndex);
	virtual Image* GetStickerImageByID(LPCTSTR strID);
	virtual CWnd*  GetCurrentWnd();
	virtual CPoint GetOffSetPoint();
	virtual CRect  GetViewRect();
	virtual Image* GetDividerImage();
	virtual Image* GetMyBubbleImage(int nIndex);
	virtual Image* GetRecentMessageImage();
	virtual Image* GetRecentMessageBKImage(BOOL bNormal);
	virtual Image* GetUserJoinImage(int nIndex, BOOL bUserJoin);
	virtual Image* GetBubbleBottomForSendProcessImage(int nIndex);
	virtual Image* GetBubbleBottomForRecvProcessImage(int nIndex);
	virtual Image* GetYourProgressBarImage(int nIndex);
	virtual Image* GetMyProgressBarImage(int nIndex);
	virtual Image* GetOtherBubbleImage(int nIndex);
	virtual Image* GetDownloadImage();
	virtual Image* GetReDownloadImage();
	virtual Image* GetCancelDownloadImage();
	virtual Image* GetCancelSendImage();
	virtual	Image* GetDownloadedImage();
	virtual BOOL   IsMouseSelection();
	virtual CPoint GetSelectionStartPoint();
	virtual void   SetCursor(int nCursor);
	virtual void   InvalidateElement(UIElement* pElement, BOOL bCalcSize);
	Image** GetBubbleImage(BOOL bMine);
	virtual Image* GetFileTransferImageByID(UINT ResID);
	virtual Image* GetFailMsgImage();
	//virtual Image* GetCacheImageByFilePath(LPCTSTR pszImageFilePath);
	virtual void   ResendChatItem(CChatItem* pChatItem);
	virtual void   OpenHyperLink(LPCTSTR strUrl);
	virtual void   StartFileTransfer(CChatItem* pChatItem);
	virtual void   CancelFileTransfer(CChatItem* pChatItem);
	virtual void   UpdateScrollInfo();
	virtual	CSize  CalcUIElementRect();
	virtual bool   IsInRecentMessageButton(CPoint pt);
	virtual CSize  CalcRecentMessageButton();
	virtual void   DrawRecentMessageButton(Graphics* pGaphics);
	virtual int    GetChatDisplayType();
	BOOL AddRecentFileMessamge(TranslateFileInfoPtr& pTranslateFileInfo);
	BOOL AddRecentChatMessamge(LPChatItemInfo pChatItemInfo);
	BOOL ShowScrollBar();
	CRecentMessageSqlite& GetRecentMessageSqlite(){ return m_rmSqlite;}
	void   UpdateView();

protected:
	virtual Image* GetFileTransferFileImage(LPCTSTR filename);

protected:
	DECLARE_MESSAGE_MAP()

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd*);
	afx_msg void OnKillFocus(CWnd*);
	afx_msg void OnChar(UINT, UINT, UINT);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg LRESULT OnUmSplitterMove(WPARAM wParam, LPARAM lParam);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	LRESULT OnVscrollView( WPARAM wParam, LPARAM lParam );
	//LRESULT OnElementUpdate(WPARAM wParam, LPARAM lParam);

	afx_msg void OnTimer(UINT_PTR nIDEvent);
protected:
	UIElement* CreateUIElementByChatItem(CChatItem* pChatItem);
	void SelectAllItem(BOOL bSelect = TRUE);

	void  DrawUIElement(Graphics* graph);
	BOOL IsDrawTime(CTime& time1, CTime& time2);
	BOOL IsDrawDate(CTime& time1, CTime& time2);
	BOOL IsSelectedItemExists();
	void OnMenuMainCopy();
	void CopyTextToClipboard();
	CString GetSelectedText();
	CString GetPlainSelectedText();
	void ShowRecentMessage();
	DWORD CalcItemFlag(int iIndex);
	void SetViewSize(SIZE &sz);
	SIZE UpdateElementRect(int nIndex);
	void UpdateElementStateByIndex(int nIndex);
	void UpdateElementStateByPointer(UIElement *e);



private:
	void _SetScrollLock(int nCurPos, int nMax);
	CRecentMessageSqlite m_rmSqlite;
private:
	int						m_nRecentMessageCursor;
	int						m_nSplitterMove;
	CScrollBarEx			m_wndScrollBar;
	//Image*                  m_pImgBG;

	Color					m_crChatBG;
	Color					m_crMyChatBG;

	CRect					m_rcRecentMessageBottom;
	CRect                   m_rcRecentMsg;
	CString                 m_strRecentMsg;
	CString                 m_strNewMessageUser;
	DWORD                   m_dwRecentTick;

	CChatItem*				m_pLastChatItem;
	VectorUIElement         m_vcUIElement;
	CCriticalSection	    m_csUIElement;
	int                     m_nScrollOneSize;

	Image*					m_pDownloadImage;
	//Image*					m_pReDownloadImage;
	Image*					m_pDownloadedImage;
	Image*					m_pCancelDownloadImage;
	Image*					m_pCancelSendImage;
	Image*					m_pImgMyBubble[9];
	Image*					m_pImgRecentMessage;
	Image*					m_pImgRecentMessageBK[2];
	Image*					m_pImageUserJoin[3];
	Image*					m_pImageUserLeave[3];

	Image*					m_pImageDivider;
	Image*					m_pImageBubbleBottomForSendProcess[3];
	Image*					m_pImageBubbleBottomForRecvProcess[3];
	Image*					m_pImgYourProgress[4];
	Image*					m_pImgMyProgress[2];
	Image*					m_pImgOtherProgress[2];
	Image*					m_pImgSendStatus[5];
	Image*					m_pImgOtherBubble[9];
	//BOOL					m_bLButtonDown;
	BOOL					m_bMouseInRecentMsgRect;
	BOOL					m_bMouseSelection;
	CPoint					m_ptSelectionStart;
	CRect					m_rcRecentMessage[3];
	//typedef std::map<CString, Image*> ImageByPathMap;   //GetCacheImageByFilePath
	//ImageByPathMap			m_imageByPathMap;
	int                     m_nChatDisplayType;
	BOOL					m_bRecentMessagePress;

	HWND					m_hWndToolTip;
	TOOLINFO				m_ToolInfo;
	bool					m_bMouseTrack;
	CTime					m_tBuddyLastTime;
	CTime					m_tMyLastTime;

	int						m_nStartSelTextIndex;
	int						m_nEndSelTextIndex;
	BOOL				    m_bMouseDown;
};
